//
// Copyright 2021 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////
// This file is generated by a script.  Do not edit directly.  Edit the
// schema.template.cpp file to make changes.

#include "pxr/imaging/hd/extComputationOutputSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdExtComputationOutputSchemaTokens,
    HDEXTCOMPUTATIONOUTPUT_SCHEMA_TOKENS);



HdTokenDataSourceHandle
HdExtComputationOutputSchema::GetName()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdExtComputationOutputSchemaTokens->name);
}

HdTupleTypeDataSourceHandle
HdExtComputationOutputSchema::GetValueType()
{
    return _GetTypedDataSource<HdTupleTypeDataSource>(
        HdExtComputationOutputSchemaTokens->valueType);
}

/*static*/
HdContainerDataSourceHandle
HdExtComputationOutputSchema::BuildRetained(
        const HdTokenDataSourceHandle &name,
        const HdTupleTypeDataSourceHandle &valueType
)
{
    TfToken names[2];
    HdDataSourceBaseHandle values[2];

    size_t count = 0;
    if (name) {
        names[count] = HdExtComputationOutputSchemaTokens->name;
        values[count++] = name;
    }

    if (valueType) {
        names[count] = HdExtComputationOutputSchemaTokens->valueType;
        values[count++] = valueType;
    }

    return HdRetainedContainerDataSource::New(count, names, values);
}


HdExtComputationOutputSchema::Builder &
HdExtComputationOutputSchema::Builder::SetName(
    const HdTokenDataSourceHandle &name)
{
    _name = name;
    return *this;
}

HdExtComputationOutputSchema::Builder &
HdExtComputationOutputSchema::Builder::SetValueType(
    const HdTupleTypeDataSourceHandle &valueType)
{
    _valueType = valueType;
    return *this;
}

HdContainerDataSourceHandle
HdExtComputationOutputSchema::Builder::Build()
{
    return HdExtComputationOutputSchema::BuildRetained(
        _name,
        _valueType
    );
}


PXR_NAMESPACE_CLOSE_SCOPE