//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* ** This file is generated by a script.  Do not edit directly.  Edit     ** */
/* ** defs.py or the (*)Schema.template.cpp files to make changes.         ** */
/* ************************************************************************** */

#include "pxr/imaging/hd/instanceCategoriesSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdInstanceCategoriesSchemaTokens,
    HDINSTANCECATEGORIES_SCHEMA_TOKENS);



HdVectorDataSourceHandle
HdInstanceCategoriesSchema::GetCategoriesValues()
{
    return _GetTypedDataSource<HdVectorDataSource>(
        HdInstanceCategoriesSchemaTokens->categoriesValues);
}

/*static*/
HdContainerDataSourceHandle
HdInstanceCategoriesSchema::BuildRetained(
        const HdVectorDataSourceHandle &categoriesValues
)
{
    TfToken names[1];
    HdDataSourceBaseHandle values[1];

    size_t count = 0;
    if (categoriesValues) {
        names[count] = HdInstanceCategoriesSchemaTokens->categoriesValues;
        values[count++] = categoriesValues;
    }

    return HdRetainedContainerDataSource::New(count, names, values);
}

/*static*/
HdInstanceCategoriesSchema
HdInstanceCategoriesSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return HdInstanceCategoriesSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                HdInstanceCategoriesSchemaTokens->instanceCategories))
        : nullptr);
}

/*static*/
const TfToken &
HdInstanceCategoriesSchema::GetSchemaToken()
{
    return HdInstanceCategoriesSchemaTokens->instanceCategories;
} 
/*static*/
const HdDataSourceLocator &
HdInstanceCategoriesSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(
        HdInstanceCategoriesSchemaTokens->instanceCategories
    );
    return locator;
} 
HdInstanceCategoriesSchema::Builder &
HdInstanceCategoriesSchema::Builder::SetCategoriesValues(
    const HdVectorDataSourceHandle &categoriesValues)
{
    _categoriesValues = categoriesValues;
    return *this;
}

HdContainerDataSourceHandle
HdInstanceCategoriesSchema::Builder::Build()
{
    return HdInstanceCategoriesSchema::BuildRetained(
        _categoriesValues
    );
}


PXR_NAMESPACE_CLOSE_SCOPE