//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* ** This file is generated by a script.  Do not edit directly.  Edit     ** */
/* ** defs.py or the (*)Schema.template.cpp files to make changes.         ** */
/* ************************************************************************** */

#include "pxr/imaging/hd/renderProductSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdRenderProductSchemaTokens,
    HDRENDERPRODUCT_SCHEMA_TOKENS);



HdPathDataSourceHandle
HdRenderProductSchema::GetPath()
{
    return _GetTypedDataSource<HdPathDataSource>(
        HdRenderProductSchemaTokens->path);
}

HdTokenDataSourceHandle
HdRenderProductSchema::GetType()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdRenderProductSchemaTokens->type);
}

HdTokenDataSourceHandle
HdRenderProductSchema::GetName()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdRenderProductSchemaTokens->name);
}

HdVec2iDataSourceHandle
HdRenderProductSchema::GetResolution()
{
    return _GetTypedDataSource<HdVec2iDataSource>(
        HdRenderProductSchemaTokens->resolution);
}

HdRenderVarVectorSchema
HdRenderProductSchema::GetRenderVars()
{
    return HdRenderVarVectorSchema(_GetTypedDataSource<HdVectorDataSource>(
        HdRenderProductSchemaTokens->renderVars));
}

HdPathDataSourceHandle
HdRenderProductSchema::GetCameraPrim()
{
    return _GetTypedDataSource<HdPathDataSource>(
        HdRenderProductSchemaTokens->cameraPrim);
}

HdFloatDataSourceHandle
HdRenderProductSchema::GetPixelAspectRatio()
{
    return _GetTypedDataSource<HdFloatDataSource>(
        HdRenderProductSchemaTokens->pixelAspectRatio);
}

HdTokenDataSourceHandle
HdRenderProductSchema::GetAspectRatioConformPolicy()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        HdRenderProductSchemaTokens->aspectRatioConformPolicy);
}

HdVec2fDataSourceHandle
HdRenderProductSchema::GetApertureSize()
{
    return _GetTypedDataSource<HdVec2fDataSource>(
        HdRenderProductSchemaTokens->apertureSize);
}

HdVec4fDataSourceHandle
HdRenderProductSchema::GetDataWindowNDC()
{
    return _GetTypedDataSource<HdVec4fDataSource>(
        HdRenderProductSchemaTokens->dataWindowNDC);
}

HdBoolDataSourceHandle
HdRenderProductSchema::GetDisableMotionBlur()
{
    return _GetTypedDataSource<HdBoolDataSource>(
        HdRenderProductSchemaTokens->disableMotionBlur);
}

HdContainerDataSourceHandle
HdRenderProductSchema::GetNamespacedSettings()
{
    return _GetTypedDataSource<HdContainerDataSource>(
        HdRenderProductSchemaTokens->namespacedSettings);
}

/*static*/
HdContainerDataSourceHandle
HdRenderProductSchema::BuildRetained(
        const HdPathDataSourceHandle &path,
        const HdTokenDataSourceHandle &type,
        const HdTokenDataSourceHandle &name,
        const HdVec2iDataSourceHandle &resolution,
        const HdVectorDataSourceHandle &renderVars,
        const HdPathDataSourceHandle &cameraPrim,
        const HdFloatDataSourceHandle &pixelAspectRatio,
        const HdTokenDataSourceHandle &aspectRatioConformPolicy,
        const HdVec2fDataSourceHandle &apertureSize,
        const HdVec4fDataSourceHandle &dataWindowNDC,
        const HdBoolDataSourceHandle &disableMotionBlur,
        const HdContainerDataSourceHandle &namespacedSettings
)
{
    TfToken _names[12];
    HdDataSourceBaseHandle _values[12];

    size_t _count = 0;
    if (path) {
        _names[_count] = HdRenderProductSchemaTokens->path;
        _values[_count++] = path;
    }

    if (type) {
        _names[_count] = HdRenderProductSchemaTokens->type;
        _values[_count++] = type;
    }

    if (name) {
        _names[_count] = HdRenderProductSchemaTokens->name;
        _values[_count++] = name;
    }

    if (resolution) {
        _names[_count] = HdRenderProductSchemaTokens->resolution;
        _values[_count++] = resolution;
    }

    if (renderVars) {
        _names[_count] = HdRenderProductSchemaTokens->renderVars;
        _values[_count++] = renderVars;
    }

    if (cameraPrim) {
        _names[_count] = HdRenderProductSchemaTokens->cameraPrim;
        _values[_count++] = cameraPrim;
    }

    if (pixelAspectRatio) {
        _names[_count] = HdRenderProductSchemaTokens->pixelAspectRatio;
        _values[_count++] = pixelAspectRatio;
    }

    if (aspectRatioConformPolicy) {
        _names[_count] = HdRenderProductSchemaTokens->aspectRatioConformPolicy;
        _values[_count++] = aspectRatioConformPolicy;
    }

    if (apertureSize) {
        _names[_count] = HdRenderProductSchemaTokens->apertureSize;
        _values[_count++] = apertureSize;
    }

    if (dataWindowNDC) {
        _names[_count] = HdRenderProductSchemaTokens->dataWindowNDC;
        _values[_count++] = dataWindowNDC;
    }

    if (disableMotionBlur) {
        _names[_count] = HdRenderProductSchemaTokens->disableMotionBlur;
        _values[_count++] = disableMotionBlur;
    }

    if (namespacedSettings) {
        _names[_count] = HdRenderProductSchemaTokens->namespacedSettings;
        _values[_count++] = namespacedSettings;
    }

    return HdRetainedContainerDataSource::New(_count, _names, _values);
}

/*static*/
HdRenderProductSchema
HdRenderProductSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return HdRenderProductSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                HdRenderProductSchemaTokens->renderProduct))
        : nullptr);
}

/*static*/
const TfToken &
HdRenderProductSchema::GetSchemaToken()
{
    return HdRenderProductSchemaTokens->renderProduct;
}

/*static*/
const HdDataSourceLocator &
HdRenderProductSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(
        HdRenderProductSchemaTokens->renderProduct
    );
    return locator;
} 
/*static*/
const HdDataSourceLocator &
HdRenderProductSchema::GetResolutionLocator()
{
    static const HdDataSourceLocator locator(
        HdRenderProductSchemaTokens->renderProduct,
        HdRenderProductSchemaTokens->resolution
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
HdRenderProductSchema::GetRenderVarsLocator()
{
    static const HdDataSourceLocator locator(
        HdRenderProductSchemaTokens->renderProduct,
        HdRenderProductSchemaTokens->renderVars
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
HdRenderProductSchema::GetNamespacedSettingsLocator()
{
    static const HdDataSourceLocator locator(
        HdRenderProductSchemaTokens->renderProduct,
        HdRenderProductSchemaTokens->namespacedSettings
    );
    return locator;
}


HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetPath(
    const HdPathDataSourceHandle &path)
{
    _path = path;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetType(
    const HdTokenDataSourceHandle &type)
{
    _type = type;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetName(
    const HdTokenDataSourceHandle &name)
{
    _name = name;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetResolution(
    const HdVec2iDataSourceHandle &resolution)
{
    _resolution = resolution;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetRenderVars(
    const HdVectorDataSourceHandle &renderVars)
{
    _renderVars = renderVars;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetCameraPrim(
    const HdPathDataSourceHandle &cameraPrim)
{
    _cameraPrim = cameraPrim;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetPixelAspectRatio(
    const HdFloatDataSourceHandle &pixelAspectRatio)
{
    _pixelAspectRatio = pixelAspectRatio;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetAspectRatioConformPolicy(
    const HdTokenDataSourceHandle &aspectRatioConformPolicy)
{
    _aspectRatioConformPolicy = aspectRatioConformPolicy;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetApertureSize(
    const HdVec2fDataSourceHandle &apertureSize)
{
    _apertureSize = apertureSize;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetDataWindowNDC(
    const HdVec4fDataSourceHandle &dataWindowNDC)
{
    _dataWindowNDC = dataWindowNDC;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetDisableMotionBlur(
    const HdBoolDataSourceHandle &disableMotionBlur)
{
    _disableMotionBlur = disableMotionBlur;
    return *this;
}

HdRenderProductSchema::Builder &
HdRenderProductSchema::Builder::SetNamespacedSettings(
    const HdContainerDataSourceHandle &namespacedSettings)
{
    _namespacedSettings = namespacedSettings;
    return *this;
}

HdContainerDataSourceHandle
HdRenderProductSchema::Builder::Build()
{
    return HdRenderProductSchema::BuildRetained(
        _path,
        _type,
        _name,
        _resolution,
        _renderVars,
        _cameraPrim,
        _pixelAspectRatio,
        _aspectRatioConformPolicy,
        _apertureSize,
        _dataWindowNDC,
        _disableMotionBlur,
        _namespacedSettings
    );
}


PXR_NAMESPACE_CLOSE_SCOPE