//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* ** This file is generated by a script.  Do not edit directly.  Edit     ** */
/* ** defs.py or the (*)Schema.template.cpp files to make changes.         ** */
/* ************************************************************************** */

#include "pxr/imaging/hd/sceneGlobalsSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"

#include "pxr/imaging/hd/sceneIndex.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(HdSceneGlobalsSchemaTokens,
    HDSCENEGLOBALS_SCHEMA_TOKENS);



/* static */
HdSceneGlobalsSchema
HdSceneGlobalsSchema::GetFromSceneIndex(
    const HdSceneIndexBaseRefPtr &si)
{
    if (!si) {
        TF_CODING_ERROR("Invalid input scene index provided.");
        return HdSceneGlobalsSchema(nullptr);
    }

    return GetFromParent(si->GetPrim(GetDefaultPrimPath()).dataSource);
}



HdPathDataSourceHandle
HdSceneGlobalsSchema::GetActiveRenderSettingsPrim()
{
    return _GetTypedDataSource<HdPathDataSource>(
        HdSceneGlobalsSchemaTokens->activeRenderSettingsPrim);
}

/*static*/
HdContainerDataSourceHandle
HdSceneGlobalsSchema::BuildRetained(
        const HdPathDataSourceHandle &activeRenderSettingsPrim
)
{
    TfToken names[1];
    HdDataSourceBaseHandle values[1];

    size_t count = 0;
    if (activeRenderSettingsPrim) {
        names[count] = HdSceneGlobalsSchemaTokens->activeRenderSettingsPrim;
        values[count++] = activeRenderSettingsPrim;
    }

    return HdRetainedContainerDataSource::New(count, names, values);
}

/*static*/
HdSceneGlobalsSchema
HdSceneGlobalsSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return HdSceneGlobalsSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                HdSceneGlobalsSchemaTokens->sceneGlobals))
        : nullptr);
}

/*static*/
const TfToken &
HdSceneGlobalsSchema::GetSchemaToken()
{
    return HdSceneGlobalsSchemaTokens->sceneGlobals;
} 
/*static*/
const HdDataSourceLocator &
HdSceneGlobalsSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(
        HdSceneGlobalsSchemaTokens->sceneGlobals
    );
    return locator;
} 
/*static*/
const HdDataSourceLocator &
HdSceneGlobalsSchema::GetActiveRenderSettingsPrimLocator()
{
    static const HdDataSourceLocator locator(
        HdSceneGlobalsSchemaTokens->sceneGlobals,
        HdSceneGlobalsSchemaTokens->activeRenderSettingsPrim
    );
    return locator;
}


HdSceneGlobalsSchema::Builder &
HdSceneGlobalsSchema::Builder::SetActiveRenderSettingsPrim(
    const HdPathDataSourceHandle &activeRenderSettingsPrim)
{
    _activeRenderSettingsPrim = activeRenderSettingsPrim;
    return *this;
}

HdContainerDataSourceHandle
HdSceneGlobalsSchema::Builder::Build()
{
    return HdSceneGlobalsSchema::BuildRetained(
        _activeRenderSettingsPrim
    );
}


PXR_NAMESPACE_CLOSE_SCOPE