//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* ** This file is generated by a script.  Do not edit directly.  Edit     ** */
/* ** defs.py or the (*)Schema.template.cpp files to make changes.         ** */
/* ************************************************************************** */

#include "pxr/usdImaging/usdImaging/modelSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(UsdImagingModelSchemaTokens,
    USDIMAGINGMODEL_SCHEMA_TOKENS);



HdPathDataSourceHandle
UsdImagingModelSchema::GetModelPath()
{
    return _GetTypedDataSource<HdPathDataSource>(
        UsdImagingModelSchemaTokens->modelPath);
}

HdTokenDataSourceHandle
UsdImagingModelSchema::GetKind()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingModelSchemaTokens->kind);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetAssetIdentifier()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->assetIdentifier);
}

HdStringDataSourceHandle
UsdImagingModelSchema::GetAssetName()
{
    return _GetTypedDataSource<HdStringDataSource>(
        UsdImagingModelSchemaTokens->assetName);
}

HdStringDataSourceHandle
UsdImagingModelSchema::GetAssetVersion()
{
    return _GetTypedDataSource<HdStringDataSource>(
        UsdImagingModelSchemaTokens->assetVersion);
}

HdTokenDataSourceHandle
UsdImagingModelSchema::GetDrawMode()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingModelSchemaTokens->drawMode);
}

HdBoolDataSourceHandle
UsdImagingModelSchema::GetApplyDrawMode()
{
    return _GetTypedDataSource<HdBoolDataSource>(
        UsdImagingModelSchemaTokens->applyDrawMode);
}

HdVec3fDataSourceHandle
UsdImagingModelSchema::GetDrawModeColor()
{
    return _GetTypedDataSource<HdVec3fDataSource>(
        UsdImagingModelSchemaTokens->drawModeColor);
}

HdTokenDataSourceHandle
UsdImagingModelSchema::GetCardGeometry()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingModelSchemaTokens->cardGeometry);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureXPos()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureXPos);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureYPos()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureYPos);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureZPos()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureZPos);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureXNeg()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureXNeg);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureYNeg()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureYNeg);
}

HdAssetPathDataSourceHandle
UsdImagingModelSchema::GetCardTextureZNeg()
{
    return _GetTypedDataSource<HdAssetPathDataSource>(
        UsdImagingModelSchemaTokens->cardTextureZNeg);
}

/*static*/
HdContainerDataSourceHandle
UsdImagingModelSchema::BuildRetained(
        const HdPathDataSourceHandle &modelPath,
        const HdTokenDataSourceHandle &kind,
        const HdAssetPathDataSourceHandle &assetIdentifier,
        const HdStringDataSourceHandle &assetName,
        const HdStringDataSourceHandle &assetVersion,
        const HdTokenDataSourceHandle &drawMode,
        const HdBoolDataSourceHandle &applyDrawMode,
        const HdVec3fDataSourceHandle &drawModeColor,
        const HdTokenDataSourceHandle &cardGeometry,
        const HdAssetPathDataSourceHandle &cardTextureXPos,
        const HdAssetPathDataSourceHandle &cardTextureYPos,
        const HdAssetPathDataSourceHandle &cardTextureZPos,
        const HdAssetPathDataSourceHandle &cardTextureXNeg,
        const HdAssetPathDataSourceHandle &cardTextureYNeg,
        const HdAssetPathDataSourceHandle &cardTextureZNeg
)
{
    TfToken _names[15];
    HdDataSourceBaseHandle _values[15];

    size_t _count = 0;
    if (modelPath) {
        _names[_count] = UsdImagingModelSchemaTokens->modelPath;
        _values[_count++] = modelPath;
    }

    if (kind) {
        _names[_count] = UsdImagingModelSchemaTokens->kind;
        _values[_count++] = kind;
    }

    if (assetIdentifier) {
        _names[_count] = UsdImagingModelSchemaTokens->assetIdentifier;
        _values[_count++] = assetIdentifier;
    }

    if (assetName) {
        _names[_count] = UsdImagingModelSchemaTokens->assetName;
        _values[_count++] = assetName;
    }

    if (assetVersion) {
        _names[_count] = UsdImagingModelSchemaTokens->assetVersion;
        _values[_count++] = assetVersion;
    }

    if (drawMode) {
        _names[_count] = UsdImagingModelSchemaTokens->drawMode;
        _values[_count++] = drawMode;
    }

    if (applyDrawMode) {
        _names[_count] = UsdImagingModelSchemaTokens->applyDrawMode;
        _values[_count++] = applyDrawMode;
    }

    if (drawModeColor) {
        _names[_count] = UsdImagingModelSchemaTokens->drawModeColor;
        _values[_count++] = drawModeColor;
    }

    if (cardGeometry) {
        _names[_count] = UsdImagingModelSchemaTokens->cardGeometry;
        _values[_count++] = cardGeometry;
    }

    if (cardTextureXPos) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureXPos;
        _values[_count++] = cardTextureXPos;
    }

    if (cardTextureYPos) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureYPos;
        _values[_count++] = cardTextureYPos;
    }

    if (cardTextureZPos) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureZPos;
        _values[_count++] = cardTextureZPos;
    }

    if (cardTextureXNeg) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureXNeg;
        _values[_count++] = cardTextureXNeg;
    }

    if (cardTextureYNeg) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureYNeg;
        _values[_count++] = cardTextureYNeg;
    }

    if (cardTextureZNeg) {
        _names[_count] = UsdImagingModelSchemaTokens->cardTextureZNeg;
        _values[_count++] = cardTextureZNeg;
    }

    return HdRetainedContainerDataSource::New(_count, _names, _values);
}

/*static*/
UsdImagingModelSchema
UsdImagingModelSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return UsdImagingModelSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                UsdImagingModelSchemaTokens->model))
        : nullptr);
}

/*static*/
const TfToken &
UsdImagingModelSchema::GetSchemaToken()
{
    return UsdImagingModelSchemaTokens->model;
}

/*static*/
const HdDataSourceLocator &
UsdImagingModelSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingModelSchemaTokens->model
    );
    return locator;
} 
/*static*/
const HdDataSourceLocator &
UsdImagingModelSchema::GetDrawModeLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingModelSchemaTokens->model,
        UsdImagingModelSchemaTokens->drawMode
    );
    return locator;
}


UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetModelPath(
    const HdPathDataSourceHandle &modelPath)
{
    _modelPath = modelPath;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetKind(
    const HdTokenDataSourceHandle &kind)
{
    _kind = kind;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetAssetIdentifier(
    const HdAssetPathDataSourceHandle &assetIdentifier)
{
    _assetIdentifier = assetIdentifier;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetAssetName(
    const HdStringDataSourceHandle &assetName)
{
    _assetName = assetName;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetAssetVersion(
    const HdStringDataSourceHandle &assetVersion)
{
    _assetVersion = assetVersion;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetDrawMode(
    const HdTokenDataSourceHandle &drawMode)
{
    _drawMode = drawMode;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetApplyDrawMode(
    const HdBoolDataSourceHandle &applyDrawMode)
{
    _applyDrawMode = applyDrawMode;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetDrawModeColor(
    const HdVec3fDataSourceHandle &drawModeColor)
{
    _drawModeColor = drawModeColor;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardGeometry(
    const HdTokenDataSourceHandle &cardGeometry)
{
    _cardGeometry = cardGeometry;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureXPos(
    const HdAssetPathDataSourceHandle &cardTextureXPos)
{
    _cardTextureXPos = cardTextureXPos;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureYPos(
    const HdAssetPathDataSourceHandle &cardTextureYPos)
{
    _cardTextureYPos = cardTextureYPos;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureZPos(
    const HdAssetPathDataSourceHandle &cardTextureZPos)
{
    _cardTextureZPos = cardTextureZPos;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureXNeg(
    const HdAssetPathDataSourceHandle &cardTextureXNeg)
{
    _cardTextureXNeg = cardTextureXNeg;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureYNeg(
    const HdAssetPathDataSourceHandle &cardTextureYNeg)
{
    _cardTextureYNeg = cardTextureYNeg;
    return *this;
}

UsdImagingModelSchema::Builder &
UsdImagingModelSchema::Builder::SetCardTextureZNeg(
    const HdAssetPathDataSourceHandle &cardTextureZNeg)
{
    _cardTextureZNeg = cardTextureZNeg;
    return *this;
}

HdContainerDataSourceHandle
UsdImagingModelSchema::Builder::Build()
{
    return UsdImagingModelSchema::BuildRetained(
        _modelPath,
        _kind,
        _assetIdentifier,
        _assetName,
        _assetVersion,
        _drawMode,
        _applyDrawMode,
        _drawModeColor,
        _cardGeometry,
        _cardTextureXPos,
        _cardTextureYPos,
        _cardTextureZPos,
        _cardTextureXNeg,
        _cardTextureYNeg,
        _cardTextureZNeg
    );
}


PXR_NAMESPACE_CLOSE_SCOPE