//
// Copyright 2023 Pixar
//
// Licensed under the Apache License, Version 2.0 (the "Apache License")
// with the following modification; you may not use this file except in
// compliance with the Apache License and the following modification to it:
// Section 6. Trademarks. is deleted and replaced with:
//
// 6. Trademarks. This License does not grant permission to use the trade
//    names, trademarks, service marks, or product names of the Licensor
//    and its affiliates, except as required to comply with Section 4(c) of
//    the License and to reproduce the content of the NOTICE file.
//
// You may obtain a copy of the Apache License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the Apache License with the above modification is
// distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
// KIND, either express or implied. See the Apache License for the specific
// language governing permissions and limitations under the Apache License.
//
////////////////////////////////////////////////////////////////////////

/* ************************************************************************** */
/* ** This file is generated by a script.  Do not edit directly.  Edit     ** */
/* ** defs.py or the (*)Schema.template.cpp files to make changes.         ** */
/* ************************************************************************** */

#include "pxr/usdImaging/usdImaging/usdRenderSettingsSchema.h"
#include "pxr/imaging/hd/retainedDataSource.h"

#include "pxr/base/trace/trace.h"


PXR_NAMESPACE_OPEN_SCOPE

TF_DEFINE_PUBLIC_TOKENS(UsdImagingUsdRenderSettingsSchemaTokens,
    USDIMAGINGUSDRENDERSETTINGS_SCHEMA_TOKENS);



HdVec2iDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetResolution()
{
    return _GetTypedDataSource<HdVec2iDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->resolution);
}

HdFloatDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetPixelAspectRatio()
{
    return _GetTypedDataSource<HdFloatDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->pixelAspectRatio);
}

HdTokenDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetAspectRatioConformPolicy()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->aspectRatioConformPolicy);
}

HdVec4fDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetDataWindowNDC()
{
    return _GetTypedDataSource<HdVec4fDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->dataWindowNDC);
}

HdBoolDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetDisableMotionBlur()
{
    return _GetTypedDataSource<HdBoolDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->disableMotionBlur);
}

HdPathDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetCamera()
{
    return _GetTypedDataSource<HdPathDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->camera);
}

HdTokenArrayDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetIncludedPurposes()
{
    return _GetTypedDataSource<HdTokenArrayDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->includedPurposes);
}

HdTokenArrayDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetMaterialBindingPurposes()
{
    return _GetTypedDataSource<HdTokenArrayDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->materialBindingPurposes);
}

HdTokenDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetRenderingColorSpace()
{
    return _GetTypedDataSource<HdTokenDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->renderingColorSpace);
}

HdPathArrayDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetProducts()
{
    return _GetTypedDataSource<HdPathArrayDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->products);
}

HdContainerDataSourceHandle
UsdImagingUsdRenderSettingsSchema::GetNamespacedSettings()
{
    return _GetTypedDataSource<HdContainerDataSource>(
        UsdImagingUsdRenderSettingsSchemaTokens->namespacedSettings);
}

/*static*/
HdContainerDataSourceHandle
UsdImagingUsdRenderSettingsSchema::BuildRetained(
        const HdVec2iDataSourceHandle &resolution,
        const HdFloatDataSourceHandle &pixelAspectRatio,
        const HdTokenDataSourceHandle &aspectRatioConformPolicy,
        const HdVec4fDataSourceHandle &dataWindowNDC,
        const HdBoolDataSourceHandle &disableMotionBlur,
        const HdPathDataSourceHandle &camera,
        const HdTokenArrayDataSourceHandle &includedPurposes,
        const HdTokenArrayDataSourceHandle &materialBindingPurposes,
        const HdTokenDataSourceHandle &renderingColorSpace,
        const HdPathArrayDataSourceHandle &products,
        const HdContainerDataSourceHandle &namespacedSettings
)
{
    TfToken names[11];
    HdDataSourceBaseHandle values[11];

    size_t count = 0;
    if (resolution) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->resolution;
        values[count++] = resolution;
    }

    if (pixelAspectRatio) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->pixelAspectRatio;
        values[count++] = pixelAspectRatio;
    }

    if (aspectRatioConformPolicy) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->aspectRatioConformPolicy;
        values[count++] = aspectRatioConformPolicy;
    }

    if (dataWindowNDC) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->dataWindowNDC;
        values[count++] = dataWindowNDC;
    }

    if (disableMotionBlur) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->disableMotionBlur;
        values[count++] = disableMotionBlur;
    }

    if (camera) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->camera;
        values[count++] = camera;
    }

    if (includedPurposes) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->includedPurposes;
        values[count++] = includedPurposes;
    }

    if (materialBindingPurposes) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->materialBindingPurposes;
        values[count++] = materialBindingPurposes;
    }

    if (renderingColorSpace) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->renderingColorSpace;
        values[count++] = renderingColorSpace;
    }

    if (products) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->products;
        values[count++] = products;
    }

    if (namespacedSettings) {
        names[count] = UsdImagingUsdRenderSettingsSchemaTokens->namespacedSettings;
        values[count++] = namespacedSettings;
    }

    return HdRetainedContainerDataSource::New(count, names, values);
}

/*static*/
UsdImagingUsdRenderSettingsSchema
UsdImagingUsdRenderSettingsSchema::GetFromParent(
        const HdContainerDataSourceHandle &fromParentContainer)
{
    return UsdImagingUsdRenderSettingsSchema(
        fromParentContainer
        ? HdContainerDataSource::Cast(fromParentContainer->Get(
                UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings))
        : nullptr);
}

/*static*/
const TfToken &
UsdImagingUsdRenderSettingsSchema::GetSchemaToken()
{
    return UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings;
} 
/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetDefaultLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings
    );
    return locator;
} 
/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetResolutionLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->resolution
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetPixelAspectRatioLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->pixelAspectRatio
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetAspectRatioConformPolicyLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->aspectRatioConformPolicy
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetDataWindowNDCLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->dataWindowNDC
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetDisableMotionBlurLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->disableMotionBlur
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetCameraLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->camera
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetIncludedPurposesLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->includedPurposes
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetMaterialBindingPurposesLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->materialBindingPurposes
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetRenderingColorSpaceLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->renderingColorSpace
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetProductsLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->products
    );
    return locator;
}

/*static*/
const HdDataSourceLocator &
UsdImagingUsdRenderSettingsSchema::GetNamespacedSettingsLocator()
{
    static const HdDataSourceLocator locator(
        UsdImagingUsdRenderSettingsSchemaTokens->__usdRenderSettings,
        UsdImagingUsdRenderSettingsSchemaTokens->namespacedSettings
    );
    return locator;
}


UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetResolution(
    const HdVec2iDataSourceHandle &resolution)
{
    _resolution = resolution;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetPixelAspectRatio(
    const HdFloatDataSourceHandle &pixelAspectRatio)
{
    _pixelAspectRatio = pixelAspectRatio;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetAspectRatioConformPolicy(
    const HdTokenDataSourceHandle &aspectRatioConformPolicy)
{
    _aspectRatioConformPolicy = aspectRatioConformPolicy;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetDataWindowNDC(
    const HdVec4fDataSourceHandle &dataWindowNDC)
{
    _dataWindowNDC = dataWindowNDC;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetDisableMotionBlur(
    const HdBoolDataSourceHandle &disableMotionBlur)
{
    _disableMotionBlur = disableMotionBlur;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetCamera(
    const HdPathDataSourceHandle &camera)
{
    _camera = camera;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetIncludedPurposes(
    const HdTokenArrayDataSourceHandle &includedPurposes)
{
    _includedPurposes = includedPurposes;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetMaterialBindingPurposes(
    const HdTokenArrayDataSourceHandle &materialBindingPurposes)
{
    _materialBindingPurposes = materialBindingPurposes;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetRenderingColorSpace(
    const HdTokenDataSourceHandle &renderingColorSpace)
{
    _renderingColorSpace = renderingColorSpace;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetProducts(
    const HdPathArrayDataSourceHandle &products)
{
    _products = products;
    return *this;
}

UsdImagingUsdRenderSettingsSchema::Builder &
UsdImagingUsdRenderSettingsSchema::Builder::SetNamespacedSettings(
    const HdContainerDataSourceHandle &namespacedSettings)
{
    _namespacedSettings = namespacedSettings;
    return *this;
}

HdContainerDataSourceHandle
UsdImagingUsdRenderSettingsSchema::Builder::Build()
{
    return UsdImagingUsdRenderSettingsSchema::BuildRetained(
        _resolution,
        _pixelAspectRatio,
        _aspectRatioConformPolicy,
        _dataWindowNDC,
        _disableMotionBlur,
        _camera,
        _includedPurposes,
        _materialBindingPurposes,
        _renderingColorSpace,
        _products,
        _namespacedSettings
    );
}


PXR_NAMESPACE_CLOSE_SCOPE